'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var iterableSearch = _interopDefault(require('@extra-iterable/search'));

/**
 * Searches a value from left.
 * @param x an array
 * @param v search value
 * @param fc compare function (a, b)
 * @param fm map function (v, i, x)
 * @returns index of value, -1 if not found
 */
function search(x, v, fc = null, fm = null) {
    return iterableSearch(x, v, fc, fm);
}

/**
 * Checks if array has a value.
 * @param x an array
 * @param v value?
 * @param fc compare function (a, b)
 * @param fm map function (v, i, x)
 */
function isValue(x, v, fc = null, fm = null) {
    return search(x, v, fc, fm) >= 0;
}

/**
 * Checks if array has a value.
 * @param x an array
 * @param v search value
 */
function includes(x, v) {
    return isValue(x, v);
}

module.exports = includes;
